#include <linux/sdt.h>
extern void dm_rh_recovery_start(void);
extern void dm_rh_dec(void);
extern void dm_rh_update_states(void);
extern void dm_rh_recovery_prepare(void);
extern void dm_rh_recovery_end(void);
extern void dm_rh_get_state(void);
extern void dm_rh_delay(void);
extern void dm_rh_inc_pending(void);
extern void dm_rh_mark_nosync(void);
extern void __dta___rh_find_111(void);

static sdt_probedesc_t	_sdt_probes[] = {
  {"__lockstat_rw__release",  "__rh_find" /* .text.__rh_find */, 0 /* sdt_args string */, (uintptr_t)__dta___rh_find_111+0x00000000000000b8 },
  {"__lockstat_rw__acquire",  "__rh_find" /* .text.__rh_find */, 0 /* sdt_args string */, (uintptr_t)__dta___rh_find_111+0x0000000000000144 },
  {"__lockstat_rw__release",  "__rh_find" /* .text.__rh_find */, 0 /* sdt_args string */, (uintptr_t)__dta___rh_find_111+0x00000000000001c0 },
  {"__lockstat_rw__acquire",  "__rh_find" /* .text.__rh_find */, 0 /* sdt_args string */, (uintptr_t)__dta___rh_find_111+0x00000000000001ec },
  {"__lockstat_spin__release",  "__rh_find" /* .text.__rh_find */, 0 /* sdt_args string */, (uintptr_t)__dta___rh_find_111+0x00000000000002f4 },
  {"__lockstat_rw__acquire",  "dm_rh_dec" /* .text.dm_rh_dec */, 0 /* sdt_args string */, (uintptr_t)dm_rh_dec+0x0000000000000044 },
  {"__lockstat_rw__release",  "dm_rh_dec" /* .text.dm_rh_dec */, 0 /* sdt_args string */, (uintptr_t)dm_rh_dec+0x00000000000000bc },
  {"__lockstat_rw__acquire",  "dm_rh_delay" /* .text.dm_rh_delay */, 0 /* sdt_args string */, (uintptr_t)dm_rh_delay+0x0000000000000044 },
  {"__lockstat_rw__release",  "dm_rh_delay" /* .text.dm_rh_delay */, 0 /* sdt_args string */, (uintptr_t)dm_rh_delay+0x0000000000000098 },
  {"__lockstat_rw__acquire",  "dm_rh_get_state" /* .text.dm_rh_get_state */, 0 /* sdt_args string */, (uintptr_t)dm_rh_get_state+0x000000000000004c },
  {"__lockstat_rw__release",  "dm_rh_get_state" /* .text.dm_rh_get_state */, 0 /* sdt_args string */, (uintptr_t)dm_rh_get_state+0x00000000000000c4 },
  {"__lockstat_spin__release",  "dm_rh_inc_pending" /* .text.dm_rh_inc_pending */, 0 /* sdt_args string */, (uintptr_t)dm_rh_inc_pending+0x0000000000000050 },
  {"__lockstat_rw__release",  "dm_rh_inc_pending" /* .text.dm_rh_inc_pending */, 0 /* sdt_args string */, (uintptr_t)dm_rh_inc_pending+0x0000000000000074 },
  {"__lockstat_rw__acquire",  "dm_rh_inc_pending" /* .text.dm_rh_inc_pending */, 0 /* sdt_args string */, (uintptr_t)dm_rh_inc_pending+0x00000000000000c8 },
  {"__lockstat_spin__release",  "dm_rh_inc_pending" /* .text.dm_rh_inc_pending */, 0 /* sdt_args string */, (uintptr_t)dm_rh_inc_pending+0x000000000000013c },
  {"__lockstat_rw__acquire",  "dm_rh_mark_nosync" /* .text.dm_rh_mark_nosync */, 0 /* sdt_args string */, (uintptr_t)dm_rh_mark_nosync+0x0000000000000088 },
  {"__lockstat_rw__release",  "dm_rh_mark_nosync" /* .text.dm_rh_mark_nosync */, 0 /* sdt_args string */, (uintptr_t)dm_rh_mark_nosync+0x00000000000000bc },
  {"__lockstat_spin__release",  "dm_rh_recovery_end" /* .text.dm_rh_recovery_end */, 0 /* sdt_args string */, (uintptr_t)dm_rh_recovery_end+0x0000000000000078 },
  {"__lockstat_spin__release",  "dm_rh_recovery_prepare" /* .text.dm_rh_recovery_prepare */, 0 /* sdt_args string */, (uintptr_t)dm_rh_recovery_prepare+0x0000000000000090 },
  {"__lockstat_rw__acquire",  "dm_rh_recovery_prepare" /* .text.dm_rh_recovery_prepare */, 0 /* sdt_args string */, (uintptr_t)dm_rh_recovery_prepare+0x00000000000000f0 },
  {"__lockstat_rw__release",  "dm_rh_recovery_prepare" /* .text.dm_rh_recovery_prepare */, 0 /* sdt_args string */, (uintptr_t)dm_rh_recovery_prepare+0x0000000000000120 },
  {"__lockstat_spin__release",  "dm_rh_recovery_start" /* .text.dm_rh_recovery_start */, 0 /* sdt_args string */, (uintptr_t)dm_rh_recovery_start+0x0000000000000074 },
  {"__lockstat_rw__acquire",  "dm_rh_update_states" /* .text.dm_rh_update_states */, 0 /* sdt_args string */, (uintptr_t)dm_rh_update_states+0x0000000000000080 },
  {"__lockstat_spin__release",  "dm_rh_update_states" /* .text.dm_rh_update_states */, 0 /* sdt_args string */, (uintptr_t)dm_rh_update_states+0x0000000000000248 },
  {"__lockstat_rw__release",  "dm_rh_update_states" /* .text.dm_rh_update_states */, 0 /* sdt_args string */, (uintptr_t)dm_rh_update_states+0x0000000000000260 },
};

#define _sdt_probec	25
