#include <linux/sdt.h>
extern void usb_gadget_set_selfpowered(void);
extern void usb_gadget_clear_selfpowered(void);
extern void usb_ep_set_halt(void);
extern void usb_ep_queue(void);
extern void usb_gadget_vbus_connect(void);
extern void usb_ep_set_wedge(void);
extern void usb_ep_disable(void);
extern void usb_ep_clear_halt(void);
extern void usb_gadget_deactivate(void);
extern void usb_ep_dequeue(void);
extern void usb_ep_fifo_flush(void);
extern void usb_ep_set_maxpacket_limit(void);
extern void usb_gadget_wakeup(void);
extern void usb_gadget_vbus_disconnect(void);
extern void usb_gadget_connect(void);
extern void usb_gadget_vbus_draw(void);
extern void usb_gadget_activate(void);
extern void usb_ep_free_request(void);
extern void usb_ep_enable(void);
extern void usb_ep_alloc_request(void);
extern void usb_gadget_giveback_request(void);
extern void usb_gadget_frame_number(void);
extern void usb_gadget_disconnect(void);
extern void usb_ep_fifo_status(void);

static sdt_probedesc_t	_sdt_probes[] = {
  {"__perf_usb_ep_alloc_request",  "usb_ep_alloc_request" /* .text.usb_ep_alloc_request */, 0 /* sdt_args string */, (uintptr_t)usb_ep_alloc_request+0x0000000000000058 },
  {"__perf_usb_ep_clear_halt",  "usb_ep_clear_halt" /* .text.usb_ep_clear_halt */, 0 /* sdt_args string */, (uintptr_t)usb_ep_clear_halt+0x0000000000000038 },
  {"__perf_usb_ep_dequeue",  "usb_ep_dequeue" /* .text.usb_ep_dequeue */, 0 /* sdt_args string */, (uintptr_t)usb_ep_dequeue+0x0000000000000044 },
  {"__perf_usb_ep_disable",  "usb_ep_disable" /* .text.usb_ep_disable */, 0 /* sdt_args string */, (uintptr_t)usb_ep_disable+0x0000000000000040 },
  {"__perf_usb_ep_enable",  "usb_ep_enable" /* .text.usb_ep_enable */, 0 /* sdt_args string */, (uintptr_t)usb_ep_enable+0x0000000000000044 },
  {"__perf_usb_ep_fifo_flush",  "usb_ep_fifo_flush" /* .text.usb_ep_fifo_flush */, 0 /* sdt_args string */, (uintptr_t)usb_ep_fifo_flush+0x0000000000000034 },
  {"__perf_usb_ep_fifo_status",  "usb_ep_fifo_status" /* .text.usb_ep_fifo_status */, 0 /* sdt_args string */, (uintptr_t)usb_ep_fifo_status+0x0000000000000038 },
  {"__perf_usb_ep_free_request",  "usb_ep_free_request" /* .text.usb_ep_free_request */, 0 /* sdt_args string */, (uintptr_t)usb_ep_free_request+0x0000000000000028 },
  {"__perf_usb_ep_queue",  "usb_ep_queue" /* .text.usb_ep_queue */, 0 /* sdt_args string */, (uintptr_t)usb_ep_queue+0x000000000000005c },
  {"__perf_usb_ep_set_halt",  "usb_ep_set_halt" /* .text.usb_ep_set_halt */, 0 /* sdt_args string */, (uintptr_t)usb_ep_set_halt+0x0000000000000038 },
  {"__perf_usb_ep_set_maxpacket_limit",  "usb_ep_set_maxpacket_limit" /* .text.usb_ep_set_maxpacket_limit */, 0 /* sdt_args string */, (uintptr_t)usb_ep_set_maxpacket_limit+0x0000000000000030 },
  {"__perf_usb_ep_set_wedge",  "usb_ep_set_wedge" /* .text.usb_ep_set_wedge */, 0 /* sdt_args string */, (uintptr_t)usb_ep_set_wedge+0x0000000000000038 },
  {"__perf_usb_gadget_activate",  "usb_gadget_activate" /* .text.usb_gadget_activate */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_activate+0x000000000000003c },
  {"__perf_usb_gadget_clear_selfpowered",  "usb_gadget_clear_selfpowered" /* .text.usb_gadget_clear_selfpowered */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_clear_selfpowered+0x000000000000003c },
  {"__perf_usb_gadget_connect",  "usb_gadget_connect" /* .text.usb_gadget_connect */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_connect+0x0000000000000048 },
  {"__perf_usb_gadget_deactivate",  "usb_gadget_deactivate" /* .text.usb_gadget_deactivate */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_deactivate+0x000000000000004c },
  {"__perf_usb_gadget_disconnect",  "usb_gadget_disconnect" /* .text.usb_gadget_disconnect */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_disconnect+0x0000000000000048 },
  {"__perf_usb_gadget_frame_number",  "usb_gadget_frame_number" /* .text.usb_gadget_frame_number */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_frame_number+0x0000000000000034 },
  {"__perf_usb_gadget_giveback_request",  "usb_gadget_giveback_request" /* .text.usb_gadget_giveback_request */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_giveback_request+0x0000000000000038 },
  {"__perf_usb_gadget_set_selfpowered",  "usb_gadget_set_selfpowered" /* .text.usb_gadget_set_selfpowered */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_set_selfpowered+0x000000000000003c },
  {"__perf_usb_gadget_vbus_connect",  "usb_gadget_vbus_connect" /* .text.usb_gadget_vbus_connect */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_vbus_connect+0x000000000000003c },
  {"__perf_usb_gadget_vbus_disconnect",  "usb_gadget_vbus_disconnect" /* .text.usb_gadget_vbus_disconnect */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_vbus_disconnect+0x000000000000003c },
  {"__perf_usb_gadget_vbus_draw",  "usb_gadget_vbus_draw" /* .text.usb_gadget_vbus_draw */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_vbus_draw+0x0000000000000048 },
  {"__perf_usb_gadget_wakeup",  "usb_gadget_wakeup" /* .text.usb_gadget_wakeup */, 0 /* sdt_args string */, (uintptr_t)usb_gadget_wakeup+0x0000000000000038 },
};

#define _sdt_probec	24
