#include <linux/sdt.h>
extern void l2tp_tunnel_closeall(void);
extern void l2tp_session_create(void);
extern void l2tp_xmit_skb(void);
extern void __l2tp_session_unhash(void);
extern void l2tp_session_get(void);
extern void l2tp_session_get_nth(void);

static sdt_probedesc_t	_sdt_probes[] = {
  {"__lockstat_rw__acquire",  "__l2tp_session_unhash" /* .text.__l2tp_session_unhash */, 0 /* sdt_args string */, (uintptr_t)__l2tp_session_unhash+0x0000000000000064 },
  {"__lockstat_rw__release",  "__l2tp_session_unhash" /* .text.__l2tp_session_unhash */, 0 /* sdt_args string */, (uintptr_t)__l2tp_session_unhash+0x0000000000000098 },
  {"__lockstat_rw__acquire",  "l2tp_session_create" /* .text.l2tp_session_create */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_create+0x00000000000001c4 },
  {"__lockstat_rw__release",  "l2tp_session_create" /* .text.l2tp_session_create */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_create+0x0000000000000284 },
  {"__lockstat_rw__release",  "l2tp_session_create" /* .text.l2tp_session_create */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_create+0x0000000000000310 },
  {"__lockstat_rw__acquire",  "l2tp_session_get" /* .text.l2tp_session_get */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_get+0x000000000000007c },
  {"__lockstat_rw__release",  "l2tp_session_get" /* .text.l2tp_session_get */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_get+0x00000000000000e4 },
  {"__lockstat_rw__release",  "l2tp_session_get" /* .text.l2tp_session_get */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_get+0x00000000000001f8 },
  {"__lockstat_rw__acquire",  "l2tp_session_get_nth" /* .text.l2tp_session_get_nth */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_get_nth+0x0000000000000060 },
  {"__lockstat_rw__release",  "l2tp_session_get_nth" /* .text.l2tp_session_get_nth */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_get_nth+0x00000000000000d8 },
  {"__lockstat_rw__release",  "l2tp_session_get_nth" /* .text.l2tp_session_get_nth */, 0 /* sdt_args string */, (uintptr_t)l2tp_session_get_nth+0x0000000000000148 },
  {"__lockstat_rw__acquire",  "l2tp_tunnel_closeall" /* .text.l2tp_tunnel_closeall */, 0 /* sdt_args string */, (uintptr_t)l2tp_tunnel_closeall+0x0000000000000074 },
  {"__lockstat_rw__release",  "l2tp_tunnel_closeall" /* .text.l2tp_tunnel_closeall */, 0 /* sdt_args string */, (uintptr_t)l2tp_tunnel_closeall+0x00000000000000ec },
  {"__lockstat_rw__acquire",  "l2tp_tunnel_closeall" /* .text.l2tp_tunnel_closeall */, 0 /* sdt_args string */, (uintptr_t)l2tp_tunnel_closeall+0x0000000000000178 },
  {"__lockstat_rw__release",  "l2tp_tunnel_closeall" /* .text.l2tp_tunnel_closeall */, 0 /* sdt_args string */, (uintptr_t)l2tp_tunnel_closeall+0x00000000000001a4 },
  {"__lockstat_spin__release",  "l2tp_xmit_skb" /* .text.l2tp_xmit_skb */, 0 /* sdt_args string */, (uintptr_t)l2tp_xmit_skb+0x0000000000000288 },
};

#define _sdt_probec	16
